Index: /pjproject/main/pjlib-util/include/pjlib-util/scanner.h
===================================================================
--- /pjproject/main/pjlib-util/include/pjlib-util/scanner.h	(revision 42)
+++ /pjproject/main/pjlib-util/include/pjlib-util/scanner.h	(revision 43)
@@ -1,8 +1,6 @@
 /* $Id$
- *
- */
-
-#ifndef __PJ_PARSER_H__
-#define __PJ_PARSER_H__
+ */
+#ifndef __PJ_SCANNER_H__
+#define __PJ_SCANNER_H__
 
 /**
@@ -20,13 +18,5 @@
  * @brief
  * Text scanning utility.
- */
-
-/**
- * @defgroup PJ_CHARSPEC Character Filter Specification
- * @ingroup PJ_SCAN
- * @brief
- * The type pj_char_spec is a specification of character set used in
- * scanner. Application can define multiple character specs, such as to
- * scan alpha numerics, numbers, tokens, etc.
+ *
  * @{
  */
@@ -34,98 +24,166 @@
 /**
  * This describes the type of individual character specification in
- * #pj_char_spec.
- */
-typedef pj_uint8_t pj_char_spec_element_t;
-
-/**
- * The character specification is implemented as array of boolean flags. Each
- * flag indicates the membership of the character in the spec. If the flag
- * at one position is non-zero, then the character at that position belongs
- * to the specification, and vice versa.
- */
-typedef pj_char_spec_element_t pj_char_spec[256];
-// Note: it's got to be 256 (not 128) to cater for extended character in input.
-
-/**
- * Initialize character spec.
- * @param cs the scanner character specification.
- */
-PJ_DECL(void) pj_cs_init( pj_char_spec cs);
-
-/**
- * Set the membership of the specified character to TRUE.
- * @param cs the scanner character specification.
- * @param c the character.
- */
-PJ_DECL(void) pj_cs_set( pj_char_spec cs, int c);
+ * #pj_cis_buf_t. Basicly the number of bits here
+ */
+#ifndef PJ_CIS_ELEM_TYPE
+#   define PJ_CIS_ELEM_TYPE pj_uint32_t
+#endif
+
+/**
+ * This describes the type of individual character specification in
+ * #pj_cis_buf_t.
+ */
+typedef PJ_CIS_ELEM_TYPE pj_cis_elem_t;
+
+/**
+ * Maximum number of input specification in a buffer.
+ * Effectively this means the number of bits in pj_cis_elem_t.
+ */
+#define PJ_CIS_MAX_INDEX   (sizeof(pj_cis_elem_t) << 3)
+
+/**
+ * The scanner input specification buffer.
+ */
+typedef struct pj_cis_buf_t
+{
+    pj_cis_elem_t    cis_buf[256];  /**< Must be 256 (not 128)! */
+    pj_cis_elem_t    use_mask;      /**< To keep used indexes.  */
+} pj_cis_buf_t;
+
+/**
+ * Character input specification.
+ */
+typedef struct pj_cis_t
+{
+    pj_cis_elem_t   *cis_buf;       /**< Pointer to buffer.     */
+    int              cis_id;        /**< Id.                    */
+} pj_cis_t;
+
+/**
+ * Initialize scanner input specification buffer.
+ *
+ * @param cs_buf    The scanner character specification.
+ */
+PJ_DECL(void) pj_cis_buf_init(pj_cis_buf_t *cs_buf);
+
+/**
+ * Create a new input specification.
+ *
+ * @param cs_buf    Specification buffer.
+ * @param cis       Character input specification to be initialized.
+ *
+ * @return          PJ_SUCCESS if new specification has been successfully
+ *                  created, or PJ_ETOOMANY if there are already too many
+ *                  specifications in the buffer.
+ */
+PJ_DECL(pj_status_t) pj_cis_init(pj_cis_buf_t *cs_buf, pj_cis_t *cis);
+
+/**
+ * Create a new input specification based on an existing specification.
+ *
+ * @param new_cis   The new specification to be initialized.
+ * @param existing  The existing specification, from which the input
+ *                  bitmask will be copied to the new specification.
+ *
+ * @return          PJ_SUCCESS if new specification has been successfully
+ *                  created, or PJ_ETOOMANY if there are already too many
+ *                  specifications in the buffer.
+ */
+PJ_DECL(pj_status_t) pj_cis_dup(pj_cis_t *new_cis, pj_cis_t *existing);
+
+/**
+ * Set the membership of the specified character.
+ * Note that this is a macro, and arguments may be evaluated more than once.
+ *
+ * @param cis       Pointer to character input specification.
+ * @param c         The character.
+ */
+#define PJ_CIS_SET(cis,c)   ((cis)->cis_buf[(c)] |= (1 << (cis)->cis_id))
+
+/**
+ * Remove the membership of the specified character.
+ * Note that this is a macro, and arguments may be evaluated more than once.
+ *
+ * @param cis       Pointer to character input specification.
+ * @param c         The character to be removed from the membership.
+ */
+#define PJ_CIS_CLR(cis,c)   ((cis)->cis_buf[c] &= ~(1 << (cis)->cis_id))
+
+/**
+ * Check the membership of the specified character.
+ * Note that this is a macro, and arguments may be evaluated more than once.
+ *
+ * @param cis       Pointer to character input specification.
+ * @param c         The character.
+ */
+#define PJ_CIS_ISSET(cis,c) ((cis)->cis_buf[c] & (1 << (cis)->cis_id))
 
 /**
  * Add the characters in the specified range '[cstart, cend)' to the 
  * specification (the last character itself ('cend') is not added).
- * @param cs the scanner character specification.
- * @param cstart the first character in the range.
- * @param cend the next character after the last character in the range.
- */
-PJ_DECL(void) pj_cs_add_range( pj_char_spec cs, int cstart, int cend);
+ *
+ * @param cis       The scanner character specification.
+ * @param cstart    The first character in the range.
+ * @param cend      The next character after the last character in the range.
+ */
+PJ_DECL(void) pj_cis_add_range( pj_cis_t *cis, int cstart, int cend);
 
 /**
  * Add alphabetic characters to the specification.
- * @param cs the scanner character specification.
- */
-PJ_DECL(void) pj_cs_add_alpha( pj_char_spec cs);
+ *
+ * @param cis       The scanner character specification.
+ */
+PJ_DECL(void) pj_cis_add_alpha( pj_cis_t *cis);
 
 /**
  * Add numeric characters to the specification.
- * @param cs the scanner character specification.
- */
-PJ_DECL(void) pj_cs_add_num( pj_char_spec cs);
+ *
+ * @param cis       The scanner character specification.
+ */
+PJ_DECL(void) pj_cis_add_num( pj_cis_t *cis);
 
 /**
  * Add the characters in the string to the specification.
- * @param cs the scanner character specification.
- * @param str the string.
- */
-PJ_DECL(void) pj_cs_add_str( pj_char_spec cs, const char *str);
+ *
+ * @param cis       The scanner character specification.
+ * @param str       The string.
+ */
+PJ_DECL(void) pj_cis_add_str( pj_cis_t *cis, const char *str);
 
 /**
  * Delete characters in the specified range from the specification.
- * @param cs the scanner character specification.
- * @param cstart the first character in the range.
- * @param cend the next character after the last character in the range.
- */
-PJ_DECL(void) pj_cs_del_range( pj_char_spec cs, int cstart, int cend);
+ *
+ * @param cis       The scanner character specification.
+ * @param cstart    The first character in the range.
+ * @param cend      The next character after the last character in the range.
+ */
+PJ_DECL(void) pj_cis_del_range( pj_cis_t *cis, int cstart, int cend);
 
 /**
  * Delete characters in the specified string from the specification.
- * @param cs the scanner character specification.
- * @param str the string.
- */
-PJ_DECL(void) pj_cs_del_str( pj_char_spec cs, const char *str);
+ *
+ * @param cis       The scanner character specification.
+ * @param str       The string.
+ */
+PJ_DECL(void) pj_cis_del_str( pj_cis_t *cis, const char *str);
 
 /**
  * Invert specification.
- * @param cs the scanner character specification.
- */
-PJ_DECL(void) pj_cs_invert( pj_char_spec cs );
+ *
+ * @param cis       The scanner character specification.
+ */
+PJ_DECL(void) pj_cis_invert( pj_cis_t *cis );
 
 /**
  * Check whether the specified character belongs to the specification.
- * @param cs the scanner character specification.
- * @param c the character to check for matching.
- */
-PJ_INLINE(int) pj_cs_match( const pj_char_spec cs, int c )
-{
-    return cs[c];
+ *
+ * @param cis       The scanner character specification.
+ * @param c         The character to check for matching.
+ */
+PJ_INLINE(int) pj_cis_match( const pj_cis_t *cis, int c )
+{
+    return PJ_CIS_ISSET(cis, c);
 }
 
-/**
- * @}
- */
-
-/**
- * @defgroup PJ_SCANNER Text Scanner
- * @ingroup PJ_SCAN
- * @{
- */
 
 /**
@@ -157,5 +215,6 @@
  * The callback function type to be called by the scanner when it encounters
  * syntax error.
- * @param scanner   The scanner instance that calls the callback .
+ *
+ * @param scanner       The scanner instance that calls the callback .
  */
 typedef void (*pj_syn_err_func_ptr)(struct pj_scanner *scanner);
@@ -245,5 +304,5 @@
  */
 PJ_DECL(int) pj_scan_peek( pj_scanner *scanner,
-			    const pj_char_spec spec, pj_str_t *out);
+			   const pj_cis_t *spec, pj_str_t *out);
 
 
@@ -262,5 +321,5 @@
  */
 PJ_DECL(int) pj_scan_peek_n( pj_scanner *scanner,
-			      pj_size_t len, pj_str_t *out);
+			     pj_size_t len, pj_str_t *out);
 
 
@@ -278,6 +337,6 @@
  */
 PJ_DECL(int) pj_scan_peek_until( pj_scanner *scanner,
-				  const pj_char_spec spec, 
-				  pj_str_t *out);
+				 const pj_cis_t *spec, 
+				 pj_str_t *out);
 
 
@@ -294,5 +353,5 @@
  */
 PJ_DECL(void) pj_scan_get( pj_scanner *scanner,
-			    const pj_char_spec spec, pj_str_t *out);
+			   const pj_cis_t *spec, pj_str_t *out);
 
 
@@ -318,5 +377,5 @@
  */
 PJ_DECL(void) pj_scan_get_n( pj_scanner *scanner,
-			      unsigned N, pj_str_t *out);
+			     unsigned N, pj_str_t *out);
 
 
@@ -326,5 +385,5 @@
  * @param scanner   The scanner.
  *
- * @return (unknown)
+ * @return The character.
  */
 PJ_DECL(int) pj_scan_get_char( pj_scanner *scanner );
@@ -349,5 +408,5 @@
  */
 PJ_DECL(void) pj_scan_get_until( pj_scanner *scanner,
-				  const pj_char_spec spec, pj_str_t *out);
+				 const pj_cis_t *spec, pj_str_t *out);
 
 
@@ -361,5 +420,5 @@
  */
 PJ_DECL(void) pj_scan_get_until_ch( pj_scanner *scanner, 
-				     int until_char, pj_str_t *out);
+				    int until_char, pj_str_t *out);
 
 
@@ -373,5 +432,5 @@
  */
 PJ_DECL(void) pj_scan_get_until_chr( pj_scanner *scanner,
-				      const char *until_spec, pj_str_t *out);
+				     const char *until_spec, pj_str_t *out);
 
 /** 
@@ -385,5 +444,5 @@
  */
 PJ_DECL(void) pj_scan_advance_n( pj_scanner *scanner,
-				  unsigned N, pj_bool_t skip);
+				 unsigned N, pj_bool_t skip);
 
 
@@ -446,11 +505,7 @@
  */
 
-#if PJ_FUNCTIONS_ARE_INLINED
-#  include "scanner_i.h"
+
+PJ_END_DECL
+
 #endif
 
-
-PJ_END_DECL
-
-#endif
-
Index: /pjproject/main/pjlib-util/src/pjlib-util/scanner.c
===================================================================
--- /pjproject/main/pjlib-util/src/pjlib-util/scanner.c	(revision 42)
+++ /pjproject/main/pjlib-util/src/pjlib-util/scanner.c	(revision 43)
@@ -5,4 +5,5 @@
 #include <pj/except.h>
 #include <pj/os.h>
+#include <pj/errno.h>
 
 #define PJ_SCAN_IS_SPACE(c)	((c)==' ' || (c)=='\t')
@@ -16,65 +17,97 @@
 }
 
-PJ_DEF(void) pj_cs_init( pj_char_spec cs)
-{
-    PJ_CHECK_STACK();
-    memset(cs, 0, sizeof(cs));
-}
-
-PJ_DEF(void) pj_cs_set( pj_char_spec cs, int c)
-{
-    PJ_CHECK_STACK();
-    cs[c] = 1;
-}
-
-PJ_DEF(void) pj_cs_add_range( pj_char_spec cs, int cstart, int cend)
-{
-    PJ_CHECK_STACK();
-    while (cstart != cend)
-	cs[cstart++] = 1;
-}
-
-PJ_DEF(void) pj_cs_add_alpha( pj_char_spec cs)
-{
-    pj_cs_add_range( cs, 'a', 'z'+1);
-    pj_cs_add_range( cs, 'A', 'Z'+1);
-}
-
-PJ_DEF(void) pj_cs_add_num( pj_char_spec cs)
-{
-    pj_cs_add_range( cs, '0', '9'+1);
-}
-
-PJ_DEF(void) pj_cs_add_str( pj_char_spec cs, const char *str)
-{
-    PJ_CHECK_STACK();
+PJ_DEF(void) pj_cis_buf_init( pj_cis_buf_t *cis_buf)
+{
+    pj_memset(cis_buf->cis_buf, 0, sizeof(cis_buf->cis_buf));
+    cis_buf->use_mask = 0;
+}
+
+PJ_DEF(pj_status_t) pj_cis_init(pj_cis_buf_t *cis_buf, pj_cis_t *cis)
+{
+    unsigned i;
+
+    cis->cis_buf = cis_buf->cis_buf;
+
+    for (i=0; i<PJ_CIS_MAX_INDEX; ++i) {
+        if ((cis_buf->use_mask & (1 << i)) == 0) {
+            cis->cis_index = i;
+            return PJ_SUCCESS;
+        }
+    }
+
+    cis->cis_index = PJ_CIS_MAX_INDEX;
+    return PJ_ETOOMANY;
+}
+
+PJ_DEF(pj_status_t) pj_cis_dup( pj_cis_t *new_cis, pj_cis_t *existing)
+{
+    pj_status_t status;
+    unsigned i;
+
+    status = pj_cis_init(existing->cis_buf, new_cis);
+    if (status != PJ_SUCCESS)
+        return status;
+
+    for (i=0; i<256; ++i) {
+        if (PJ_CIS_ISSET(existing, i))
+            PJ_CIS_SET(new_cis, i);
+        else
+            PJ_CIS_CLR(new_cis, i);
+    }
+
+    return PJ_SUCCESS;
+}
+
+PJ_DEF(void) pj_cis_add_range(pj_cis_t *cis, int cstart, int cend)
+{
+    while (cstart != cend) {
+        PJ_CIS_SET(cis, cstart);
+	++cstart;
+    }
+}
+
+PJ_DEF(void) pj_cis_add_alpha(pj_cis_t *cis)
+{
+    pj_cis_add_range( cis, 'a', 'z'+1);
+    pj_cis_add_range( cis, 'A', 'Z'+1);
+}
+
+PJ_DEF(void) pj_cis_add_num(pj_cis_t *cis)
+{
+    pj_cis_add_range( cis, '0', '9'+1);
+}
+
+PJ_DEF(void) pj_cis_add_str( pj_cis_t *cis, const char *str)
+{
     while (*str) {
-        cs[(int)*str] = 1;
+        PJ_CIS_SET(cis, *str);
 	++str;
     }
 }
 
-PJ_DEF(void) pj_cs_del_range( pj_char_spec cs, int cstart, int cend)
-{
-    PJ_CHECK_STACK();
-    while (cstart != cend)
-	cs[cstart++] = 0;
-}
-
-PJ_DEF(void) pj_cs_del_str( pj_char_spec cs, const char *str)
-{
-    PJ_CHECK_STACK();
+PJ_DEF(void) pj_cis_del_range( pj_cis_t *cis, int cstart, int cend)
+{
+    while (cstart != cend) {
+        PJ_CIS_CLR(cis, cstart);
+        cstart++;
+    }
+}
+
+PJ_DEF(void) pj_cis_del_str( pj_cis_t *cis, const char *str)
+{
     while (*str) {
-        cs[(int)*str] = 0;
+        PJ_CIS_CLR(cis, *str);
 	++str;
     }
 }
 
-PJ_DEF(void) pj_cs_invert( pj_char_spec cs )
+PJ_DEF(void) pj_cis_invert( pj_cis_t *cis )
 {
     unsigned i;
-    PJ_CHECK_STACK();
-    for (i=0; i<sizeof(pj_char_spec)/sizeof(cs[0]); ++i) {
-	cs[i] = (pj_char_spec_element_t) !cs[i];
+    for (i=0; i<256; ++i) {
+	if (PJ_CIS_ISSET(cis,i))
+            PJ_CIS_CLR(cis,i);
+        else
+            PJ_CIS_SET(cis,i);
     }
 }
@@ -166,5 +199,5 @@
 
 PJ_DEF(int) pj_scan_peek( pj_scanner *scanner,
-			   const pj_char_spec spec, pj_str_t *out)
+			  const pj_cis_t *spec, pj_str_t *out)
 {
     register char *s = scanner->curptr;
@@ -178,5 +211,5 @@
     }
 
-    while (PJ_SCAN_CHECK_EOF(s) && pj_cs_match(spec, *s))
+    while (PJ_SCAN_CHECK_EOF(s) && pj_cis_match(spec, *s))
 	++s;
 
@@ -204,6 +237,6 @@
 
 PJ_DEF(int) pj_scan_peek_until( pj_scanner *scanner,
-				  const pj_char_spec spec, 
-				  pj_str_t *out)
+				const pj_cis_t *spec, 
+				pj_str_t *out)
 {
     register char *s = scanner->curptr;
@@ -217,5 +250,5 @@
     }
 
-    while (PJ_SCAN_CHECK_EOF(s) && !pj_cs_match( spec, *s))
+    while (PJ_SCAN_CHECK_EOF(s) && !pj_cis_match( spec, *s))
 	++s;
 
@@ -226,5 +259,5 @@
 
 PJ_DEF(void) pj_scan_get( pj_scanner *scanner,
-			   const pj_char_spec spec, pj_str_t *out)
+			  const pj_cis_t *spec, pj_str_t *out)
 {
     register char *s = scanner->curptr;
@@ -234,5 +267,5 @@
     PJ_CHECK_STACK();
 
-    if (pj_scan_is_eof(scanner) || !pj_cs_match(spec, *s)) {
+    if (pj_scan_is_eof(scanner) || !pj_cis_match(spec, *s)) {
 	pj_scan_syntax_err(scanner);
 	return;
@@ -241,5 +274,5 @@
     do {
 	++s;
-    } while (PJ_SCAN_CHECK_EOF(s) && pj_cs_match(spec, *s));
+    } while (PJ_SCAN_CHECK_EOF(s) && pj_cis_match(spec, *s));
 
     pj_strset3(out, scanner->curptr, s);
@@ -396,5 +429,5 @@
 
 PJ_DEF(void) pj_scan_get_until( pj_scanner *scanner,
-				 const pj_char_spec spec, pj_str_t *out)
+				const pj_cis_t *spec, pj_str_t *out)
 {
     register char *s = scanner->curptr;
@@ -409,5 +442,5 @@
     }
 
-    while (PJ_SCAN_CHECK_EOF(s) && !pj_cs_match(spec, *s)) {
+    while (PJ_SCAN_CHECK_EOF(s) && !pj_cis_match(spec, *s)) {
 	++s;
     }
@@ -425,5 +458,5 @@
 
 PJ_DEF(void) pj_scan_get_until_ch( pj_scanner *scanner, 
-				    int until_char, pj_str_t *out)
+				   int until_char, pj_str_t *out)
 {
     register char *s = scanner->curptr;
Index: /pjproject/main/pjlib/build/pjlib.dsw
===================================================================
--- /pjproject/main/pjlib/build/pjlib.dsw	(revision 42)
+++ /pjproject/main/pjlib/build/pjlib.dsw	(revision 43)
@@ -24,4 +24,22 @@
 Package=<4>
 {{{
+}}}
+
+###############################################################################
+
+Project: "pjlib++_test"=".\pjlib++-test.dsp" - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+    Begin Project Dependency
+    Project_Dep_Name pjlib
+    End Project Dependency
+    Begin Project Dependency
+    Project_Dep_Name pjlib++
+    End Project Dependency
 }}}
 
@@ -58,22 +76,4 @@
 ###############################################################################
 
-Project: "pjlib++_test"=.\pjlib++-test.dsp - Package Owner=<4>
-
-Package=<5>
-{{{
-}}}
-
-Package=<4>
-{{{
-    Begin Project Dependency
-    Project_Dep_Name pjlib
-    End Project Dependency
-    Begin Project Dependency
-    Project_Dep_Name pjlib++
-    End Project Dependency
-}}}
-
-###############################################################################
-
 Global:
 
Index: /pjproject/main/pjlib/include/pj++/file.hpp
===================================================================
--- /pjproject/main/pjlib/include/pj++/file.hpp	(revision 42)
+++ /pjproject/main/pjlib/include/pj++/file.hpp	(revision 43)
@@ -1,4 +1,4 @@
-/* $Id$ */
-
+/* $Id$ 
+ */
 #ifndef __PJPP_FILE_HPP__
 #define __PJPP_FILE_HPP__
Index: /pjproject/main/pjlib/include/pj++/hash.hpp
===================================================================
--- /pjproject/main/pjlib/include/pj++/hash.hpp	(revision 42)
+++ /pjproject/main/pjlib/include/pj++/hash.hpp	(revision 43)
@@ -1,6 +1,6 @@
 /* $Id$
  */
-#ifndef __PJPP_HASH_H__
-#define __PJPP_HASH_H__
+#ifndef __PJPP_HASH_HPP__
+#define __PJPP_HASH_HPP__
 
 #include <pj++/types.hpp>
@@ -136,4 +136,4 @@
 
 
-#endif	/* __PJPP_HASH_H__ */
+#endif	/* __PJPP_HASH_HPP__ */
 
Index: /pjproject/main/pjlib/include/pj++/list.hpp
===================================================================
--- /pjproject/main/pjlib/include/pj++/list.hpp	(revision 42)
+++ /pjproject/main/pjlib/include/pj++/list.hpp	(revision 43)
@@ -1,6 +1,6 @@
 /* $Id$
  */
-#ifndef __PJPP_LIST_H__
-#define __PJPP_LIST_H__
+#ifndef __PJPP_LIST_HPP__
+#define __PJPP_LIST_HPP__
 
 #include <pj/list.h>
@@ -308,3 +308,4 @@
 
 
-#endif	/* __PJPP_LIST_H__ */
+#endif	/* __PJPP_LIST_HPP__ */
+
Index: /pjproject/main/pjlib/include/pj++/lock.hpp
===================================================================
--- /pjproject/main/pjlib/include/pj++/lock.hpp	(revision 42)
+++ /pjproject/main/pjlib/include/pj++/lock.hpp	(revision 43)
@@ -1,5 +1,6 @@
-/* $Id$ */
-#ifndef __PJPP_LOCK_H__
-#define __PJPP_LOCK_H__
+/* $Id$ 
+ */
+#ifndef __PJPP_LOCK_HPP__
+#define __PJPP_LOCK_HPP__
 
 #include <pj++/types.hpp>
@@ -128,4 +129,4 @@
 
 
-#endif	/* __PJPP_LOCK_H__ */
+#endif	/* __PJPP_LOCK_HPP__ */
 
Index: /pjproject/main/pjlib/include/pj++/os.hpp
===================================================================
--- /pjproject/main/pjlib/include/pj++/os.hpp	(revision 42)
+++ /pjproject/main/pjlib/include/pj++/os.hpp	(revision 43)
@@ -1,6 +1,6 @@
 /* $Id$
  */
-#ifndef __PJPP_OS_H__
-#define __PJPP_OS_H__
+#ifndef __PJPP_OS_HPP__
+#define __PJPP_OS_HPP__
 
 #include <pj/os.h>
@@ -785,3 +785,4 @@
 }
 
-#endif	/* __PJPP_OS_H__ */
+#endif	/* __PJPP_OS_HPP__ */
+
Index: /pjproject/main/pjlib/include/pj++/pool.hpp
===================================================================
--- /pjproject/main/pjlib/include/pj++/pool.hpp	(revision 42)
+++ /pjproject/main/pjlib/include/pj++/pool.hpp	(revision 43)
@@ -1,6 +1,6 @@
 /* $Id$
  */
-#ifndef __PJPP_POOL_H__
-#define __PJPP_POOL_H__
+#ifndef __PJPP_POOL_HPP__
+#define __PJPP_POOL_HPP__
 
 #include <pj/pool.h>
@@ -251,3 +251,4 @@
 
 
-#endif	/* __PJPP_POOL_H__ */
+#endif	/* __PJPP_POOL_HPP__ */
+
Index: /pjproject/main/pjlib/include/pj++/proactor.hpp
===================================================================
--- /pjproject/main/pjlib/include/pj++/proactor.hpp	(revision 42)
+++ /pjproject/main/pjlib/include/pj++/proactor.hpp	(revision 43)
@@ -1,6 +1,6 @@
 /* $Id$
  */
-#ifndef __PJPP_PROACTOR_H__
-#define __PJPP_PROACTOR_H__
+#ifndef __PJPP_PROACTOR_HPP__
+#define __PJPP_PROACTOR_HPP__
 
 #include <pj/ioqueue.h>
@@ -30,4 +30,5 @@
         : handler_(NULL)
     {
+	pj_ioqueue_op_key_init(this, sizeof(*this));
     }
 
@@ -38,5 +39,5 @@
         : handler_(handler)
     {
-        pj_memset(this, 0, sizeof(pj_ioqueue_op_key_t));
+	pj_ioqueue_op_key_init(this, sizeof(*this));
     }
 
@@ -498,3 +499,4 @@
 };
 
-#endif	/* __PJPP_PROACTOR_H__ */
+#endif	/* __PJPP_PROACTOR_HPP__ */
+
Index: /pjproject/main/pjlib/include/pj++/scanner.hpp
===================================================================
--- /pjproject/main/pjlib/include/pj++/scanner.hpp	(revision 42)
+++ /pjproject/main/pjlib/include/pj++/scanner.hpp	(revision 43)
@@ -1,7 +1,6 @@
 /* $Id$
- *
  */
-#ifndef __PJPP_SCANNER_H__
-#define __PJPP_SCANNER_H__
+#ifndef __PJPP_SCANNER_HPP__
+#define __PJPP_SCANNER_HPP__
 
 #include <pjlib-util/scanner.h>
@@ -171,3 +170,4 @@
 };
 
-#endif	/* __PJPP_SCANNER_H__ */
+#endif	/* __PJPP_SCANNER_HPP__ */
+
Index: /pjproject/main/pjlib/include/pj++/sock.hpp
===================================================================
--- /pjproject/main/pjlib/include/pj++/sock.hpp	(revision 42)
+++ /pjproject/main/pjlib/include/pj++/sock.hpp	(revision 43)
@@ -1,6 +1,6 @@
 /* $Id$
  */
-#ifndef __PJPP_SOCK_H__
-#define __PJPP_SOCK_H__
+#ifndef __PJPP_SOCK_HPP__
+#define __PJPP_SOCK_HPP__
 
 #include <pj/sock.h>
@@ -424,3 +424,4 @@
 
 
-#endif	/* __PJPP_SOCK_H__ */
+#endif	/* __PJPP_SOCK_HPP__ */
+
Index: /pjproject/main/pjlib/include/pj++/string.hpp
===================================================================
--- /pjproject/main/pjlib/include/pj++/string.hpp	(revision 42)
+++ /pjproject/main/pjlib/include/pj++/string.hpp	(revision 43)
@@ -1,6 +1,6 @@
 /* $Id$
  */
-#ifndef __PJPP_STRING_H__
-#define __PJPP_STRING_H__
+#ifndef __PJPP_STRING_HPP__
+#define __PJPP_STRING_HPP__
 
 #include <pj/string.h>
@@ -406,3 +406,4 @@
 };
 
-#endif	/* __PJPP_STRING_H__ */
+#endif	/* __PJPP_STRING_HPP__ */
+
Index: /pjproject/main/pjlib/include/pj++/timer.hpp
===================================================================
--- /pjproject/main/pjlib/include/pj++/timer.hpp	(revision 42)
+++ /pjproject/main/pjlib/include/pj++/timer.hpp	(revision 43)
@@ -1,6 +1,6 @@
 /* $Id$
  */
-#ifndef __PJPP_TIMER_H__
-#define __PJPP_TIMER_H__
+#ifndef __PJPP_TIMER_HPP__
+#define __PJPP_TIMER_HPP__
 
 #include <pj/timer.h>
@@ -178,3 +178,4 @@
 };
 
-#endif	/* __PJPP_TIMER_H__ */
+#endif	/* __PJPP_TIMER_HPP__ */
+
Index: /pjproject/main/pjlib/include/pj++/tree.hpp
===================================================================
--- /pjproject/main/pjlib/include/pj++/tree.hpp	(revision 42)
+++ /pjproject/main/pjlib/include/pj++/tree.hpp	(revision 43)
@@ -1,7 +1,6 @@
 /* $Id$
- *
  */
-#ifndef __PJPP_TREE_H__
-#define __PJPP_TREE_H__
+#ifndef __PJPP_TREE_HPP__
+#define __PJPP_TREE_HPP__
 
 #include <pj/rbtree.h>
@@ -110,3 +109,4 @@
 };
 
-#endif	/* __PJPP_TREE_H__ */
+#endif	/* __PJPP_TREE_HPP__ */
+
Index: /pjproject/main/pjlib/include/pj++/types.hpp
===================================================================
--- /pjproject/main/pjlib/include/pj++/types.hpp	(revision 42)
+++ /pjproject/main/pjlib/include/pj++/types.hpp	(revision 43)
@@ -1,7 +1,6 @@
 /* $Id$
- *
  */
-#ifndef __PJPP_TYPES_H__
-#define __PJPP_TYPES_H__
+#ifndef __PJPP_TYPES_HPP__
+#define __PJPP_TYPES_HPP__
 
 #include <pj/types.h>
@@ -142,3 +141,4 @@
 };
 
-#endif	/* __PJPP_TYPES_H__ */
+#endif	/* __PJPP_TYPES_HPP__ */
+
Index: /pjproject/main/pjlib/include/pj/compat/string.h
===================================================================
--- /pjproject/main/pjlib/include/pj/compat/string.h	(revision 42)
+++ /pjproject/main/pjlib/include/pj/compat/string.h	(revision 43)
@@ -41,3 +41,12 @@
 
 
+#define pj_native_strcmp        strcmp
+#define pj_native_strlen        strlen
+#define pj_native_strcpy        strcpy
+#define pj_native_strstr        strstr
+#define pj_native_strchr        strchr
+#define pj_native_strcasecmp    strcasecmp
+#define pj_native_strncasecmp   strncasecmp
+
+
 #endif	/* __PJ_COMPAT_STRING_H__ */
Index: /pjproject/main/pjlib/include/pj/config.h
===================================================================
--- /pjproject/main/pjlib/include/pj/config.h	(revision 42)
+++ /pjproject/main/pjlib/include/pj/config.h	(revision 43)
@@ -148,5 +148,5 @@
  */
 #ifndef PJ_LOG_MAX_LEVEL
-#  define PJ_LOG_MAX_LEVEL   4
+#  define PJ_LOG_MAX_LEVEL   5
 #endif
 
@@ -404,4 +404,11 @@
 #endif
 
+/**
+ * Function attributes to inform that the function may throw exception.
+ *
+ * @param x     The exception list, enclosed in parenthesis.
+ */
+#define __pj_throw__(x)
+
 
 /********************************************************************
Index: /pjproject/main/pjlib/include/pj/errno.h
===================================================================
--- /pjproject/main/pjlib/include/pj/errno.h	(revision 42)
+++ /pjproject/main/pjlib/include/pj/errno.h	(revision 43)
@@ -216,4 +216,9 @@
  */
 #define PJ_ECANCELLED	    (PJ_ERRNO_START_STATUS + 14)
+/**
+ * @hideinitializer
+ * Object already exists.
+ */
+#define PJ_EEXISTS          (PJ_ERRNO_START_STATUS + 14)
 
 /** @} */   /* pj_errnum */
Index: /pjproject/main/pjlib/include/pj/hash.h
===================================================================
--- /pjproject/main/pjlib/include/pj/hash.h	(revision 42)
+++ /pjproject/main/pjlib/include/pj/hash.h	(revision 43)
@@ -45,4 +45,19 @@
 				  const void *key, unsigned keylen);
 
+
+/**
+ * Convert the key to lowercase and calculate the hash value. The resulting
+ * string is stored in \c result.
+ *
+ * @param hval      The initial hash value, normally zero.
+ * @param result    Buffer to store the result, which must be enough to hold
+ *                  the string.
+ * @param key       The input key to be converted and calculated.
+ *
+ * @return          The hash value.
+ */
+PJ_DECL(pj_uint32_t) pj_hash_calc_tolower(pj_uint32_t hval,
+                                          char *result,
+                                          const pj_str_t *key);
 
 /**
Index: /pjproject/main/pjlib/include/pj/ioqueue.h
===================================================================
--- /pjproject/main/pjlib/include/pj/ioqueue.h	(revision 42)
+++ /pjproject/main/pjlib/include/pj/ioqueue.h	(revision 43)
@@ -342,7 +342,17 @@
 
 /**
+ * Initialize operation key.
+ *
+ * @param op_key    The operation key to be initialied.
+ * @param size	    The size of the operation key.
+ */
+PJ_DECL(void) pj_ioqueue_op_key_init( pj_ioqueue_op_key_t *op_key,
+				      pj_size_t size );
+
+/**
  * Check if operation is pending on the specified operation key.
- * The \c op_key must have been submitted as pending operation before,
- * or otherwise the result is undefined.
+ * The \c op_key must have been initialized with #pj_ioqueue_op_key_init() 
+ * or submitted as pending operation before, or otherwise the result 
+ * is undefined.
  *
  * @param key       The key.
Index: /pjproject/main/pjlib/include/pj/string.h
===================================================================
--- /pjproject/main/pjlib/include/pj/string.h	(revision 42)
+++ /pjproject/main/pjlib/include/pj/string.h	(revision 43)
@@ -13,4 +13,7 @@
 #include <pj/types.h>
 #include <pj/compat/string.h>
+#include <pj/compat/sprintf.h>
+#include <pj/compat/vsprintf.h>
+
 
 PJ_BEGIN_DECL
Index: /pjproject/main/pjlib/src/pj/errno.c
===================================================================
--- /pjproject/main/pjlib/src/pj/errno.c	(revision 42)
+++ /pjproject/main/pjlib/src/pj/errno.c	(revision 43)
@@ -31,5 +31,6 @@
     { PJ_ENOTSUP,	"Option/operation is not supported"},
     { PJ_EINVALIDOP,	"Invalid operation"},
-    { PJ_ECANCELLED,    "Operation cancelled"}
+    { PJ_ECANCELLED,    "Operation cancelled"},
+    { PJ_EEXISTS,       "Object already exists" }
 };
 
Index: /pjproject/main/pjlib/src/pj/hash.c
===================================================================
--- /pjproject/main/pjlib/src/pj/hash.c	(revision 42)
+++ /pjproject/main/pjlib/src/pj/hash.c	(revision 43)
@@ -50,4 +50,18 @@
     }
     return hash;
+}
+
+PJ_DEF(pj_uint32_t) pj_hash_calc_tolower( pj_uint32_t hval,
+                                          char *result,
+                                          const pj_str_t *key)
+{
+    long i;
+
+    for (i=0; i<key->slen; ++i) {
+	result[i] = (char)pj_tolower(key->ptr[i]);
+	hval = hval * PJ_HASH_MULTIPLIER + result[i];
+    }
+
+    return hval;
 }
 
Index: /pjproject/main/pjlib/src/pj/ioqueue_common_abs.c
===================================================================
--- /pjproject/main/pjlib/src/pj/ioqueue_common_abs.c	(revision 42)
+++ /pjproject/main/pjlib/src/pj/ioqueue_common_abs.c	(revision 43)
@@ -834,4 +834,12 @@
 #endif	/* PJ_HAS_TCP */
 
+
+PJ_DEF(void) pj_ioqueue_op_key_init( pj_ioqueue_op_key_t *op_key,
+				     pj_size_t size )
+{
+    pj_memset(op_key, 0, size);
+}
+
+
 /*
  * pj_ioqueue_is_pending()
Index: /pjproject/main/pjlib/src/pj/ioqueue_winnt.c
===================================================================
--- /pjproject/main/pjlib/src/pj/ioqueue_winnt.c	(revision 42)
+++ /pjproject/main/pjlib/src/pj/ioqueue_winnt.c	(revision 43)
@@ -893,4 +893,9 @@
 
 
+PJ_DEF(void) pj_ioqueue_op_key_init( pj_ioqueue_op_key_t *op_key,
+				     pj_size_t size )
+{
+    pj_memset(op_key, 0, size);
+}
 
 PJ_DEF(pj_bool_t) pj_ioqueue_is_pending( pj_ioqueue_key_t *key,
